"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.setCache = exports.getCache = void 0;
var cache = {};
var defaultCacheTime = 5 * 60 * 1000; // 默认缓存5分钟

var getCache = function getCache(key) {
  return cache[key] ? cache[key].data : undefined;
};

exports.getCache = getCache;

var setCache = function setCache(key, data) {
  var cacheTime = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : defaultCacheTime;

  if (cache[key]) {
    clearTimeout(cache[key].timer);
  }

  var timer = setTimeout(function () {
    delete cache[key];
  }, cacheTime);
  cache[key] = {
    data: data,
    timer: timer
  };
};

exports.setCache = setCache;