"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = debounce;

// 防抖
// 调用一定时间间隔后才执行，期间每次调用都将重新计时
function debounce(fn, timespan) {
  var timer = null;

  function cancel() {
    clearTimeout(timer);
  }

  function debounced() {
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    var context = this;
    clearTimeout(timer);
    timer = setTimeout(function () {
      fn.call.apply(fn, [context].concat(args));
    }, timespan);
  }

  debounced.cancel = cancel;
  return debounced;
}